<?php
// Author: Patrick Bose
// Copyright 2001, Cobalt Networks.  All rights reserved.
// $Id: Product.php,v 1.1 2001/03/02 19:32:19 pbose Exp $

// This class reveals product specific information 
// such as product type and available features.

global $isProductDefined;
if($isProductDefined)
  return;
$isProductDefined = true;

class Product {

	// private vars
	var $type;     // product type as returned by getProductType
	var $cce;  

	// creates a Product object 
	// params: cce reference
	// returns: nothing
	function Product(& $cce) {
		$this->cce = & $cce;
	}

	// tells you if you have a product in the raq family
	// more generic than getProductType 
	// params: none
	// returns:  boolean
	function isRaq () {
		if ( !$this->type ) 
			$this->getProductType();

		if ( $this->type == "RAQ" || $this->type =="CACHERAQ" )
			return true;
		else
			return false;	
	}

	// gets the product code from cce and converts to known type,
	// this should return something 
	// e.g. raq, qube..
	function getProductType () {
		if ( $this->type ) 
			return $this->type;

		$system = $this->cce->getObject("System", array(), "");
		$productCode = $system["productBuild"];

		if ( ereg("[0-9]R", $productCode) ) 
			$this->type = "RAQ";
		else if ( ereg("[0-9]WG", $productCode) ) 
			$this->type = "QUBE";
		else if ( ereg("[0-9]CR", $productCode) ) 
			$this->type = "CACHERAQ";
	
		return $this->type;		
	}

}
?>
