<?php
// Author: Kevin K.M. Chiu
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: EmailAddress.php,v 1.10.4.2 2001/12/05 18:00:42 ssmith Exp $

global $isEmailAddressDefined;
if($isEmailAddressDefined)
  return;
$isEmailAddressDefined = true;

include("uifc/FormField.php");
include("uifc/FormFieldBuilder.php");

class EmailAddress extends FormField {
  // private variables
  var $remote;

  // description: constructor
  // param: page: the Page object this form field lives in
  // param: id: the identifier of this object
  function EmailAddress(&$page, $id, $value = "", $im = "", $em = "") {
    // superclass constructor
    $this->FormField($page, $id, $value, $im, $em);
    $this->remote = false;
  }

  //
  // public methods
  //

  function toHtml($style = "") {
    $id = $this->getId();
    $builder = new FormFieldBuilder();
    $formField .= $builder->makeTextField($id, $this->getValue(),
		$this->getAccess(),
		$GLOBALS["_FormField_width"], null,
		$GLOBALS["_FormField_change"]
    );
    // if remote attribute set, use a different js validator.
    if ($this->isRemote()) {
	    $formField .= $builder->makeJavaScript($this,
		"top.code.EmailAddress_changeHandlerRemote",
		$GLOBALS["_FormField_TextField_submit"]);
    } else {
	    $formField .= $builder->makeJavaScript($this,
		"top.code.EmailAddress_changeHandler",
		$GLOBALS["_FormField_TextField_submit"]);
    }
    return $formField;
  }

  // description: get the remote attribute, this specifies if the js handler
  // will force the address to be of the form user@domain.com. Otherwise
  // unqualified aliases are allowed
  // returns: remote addribute in boolean
  // see: setRemote()
  function isRemote() {
    return $this->remote;
  }

  // description: set the remote attribute
  // param: fullSize: true to make the object accept only fully-qualified
  // email addresses of the form user@domain.com.  False otherwise.
  // returns: nothing
  // see: isRemote()
  function setRemote($remote) {
    $this->remote = $remote;
  }
}
