<?php
// Author: jmayer@cobalt.com
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: IntRange.php,v 1.6.2.1 2001/12/05 00:59:07 ssmith Exp $

global $isIntRangeDefined;
if($isIntRangeDefined)
  return;
$isIntRangeDefined = true;

include("uifc/FormField.php");
include("uifc/FormFieldBuilder.php");

class IntRange extends FormField {
  //
  // private variables
  //

  //
  // public methods
  //

  // description: constructor
  // param: page: the Page object this form field lives in
  // param: id: the identifier of this object
  // param: value: the default value
  // param: invalidMessage: message to be shown upon invalid input. Optional
  // param: emptyMessage: message to be shown upon empty input
  //     if the field is not optional. This message is optional
  function IntRange(&$page, $id, $value, $invalidMessage, $emptyMessage = "") {
    // superclass constructor
    $this->FormField($page, $id, $value, $invalidMessage, $emptyMessage);

    $this->isConfirm = true;
  }

  function isConfirm() {
    return $this->isConfirm;
  }

  // description: set the config flag
  // param: isConfirm: if true, a confirm field is shown
  function setConfirm($isConfirm) {
    $this->isConfirm = $isConfirm;
  }

  function toHtml($style = "") {
    $id = $this->getId();
    $access = $this->getAccess();
    $value = $this->getValue();
    
    $regs = array();
    if (ereg("^([^:]+):(.+)", $value, $regs)) {
      $low = $regs[1]; $high = $regs[2];
    } else {
      $low = $value; $high = $value;
    }
    
    $onchange = "if(this.changeHandler != null) return this.changeHandler(this); else return true;";
    $onsubmit = "return intRange_submitHandler_$id()";

    $formField = "
<TABLE BORDER=\"0\" CELLPADDING=\"0\" CELLSPACING=\"0\">
  <TR>
    <TD>
      <input type=\"hidden\" name=\"$id\" value=\"$value\">
      <input type=\"text\" name=\"low_$id\" value=\"$low\" 
      	size=\"5\" onChange=\"$onchange\" onSubmit=\"$onsubmit\">
    </td>
    <td>&nbsp;-&nbsp;</td>
    <td>
      <input type=\"text\" name=\"high_$id\" value=\"$high\"
      	size=\"5\" onChange=\"$onchange\" onSubmit=\"$onsubmit\">
    </td>
  </tr>
</table>
<SCRIPT LANGUAGE=\"javascript\">
  var high_$id = document.form.high_$id;
  var low_$id = document.form.low_$id;
  high_$id.max = 65536;
  high_$id.min = 0;
  low_$id.max = 65536;
  low_$id.min = 0;
  high_$id.changeHandler = top.code.Integer_changeHandler;
  high_$id.submitHandler = intRange_submitHandler_$id;
  low_$id.changeHandler = top.code.Integer_changeHandler;
  low_$id.submitHandler = intRange_submitHandler_$id;
  high_$id.invalidMessage = \"$this->im\"
  low_$id.invalidMessage = \"$this->im\"
  function intRange_submitHandler_$id()
  {
    if (document.form.high_$id.value - 0 < document.form.low_$id.value - 0) {
      document.form.high_$id.value = document.form.low_$id.value;
    }
    document.form.$id.value =
        document.form.low_$id.value + ':' + document.form.high_$id.value;
    if (!document.form.low_$id.value) { document.form.$id.value = ''; }
    return true;
  }
</SCRIPT>
";
    return $formField;
  }
}
