<?php
// Author: Kevin K.M. Chiu
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: Integer.php,v 1.15 2001/04/13 01:55:21 kevin Exp $

global $isIntegerDefined;
if($isIntegerDefined)
  return;
$isIntegerDefined = true;

include("uifc/Number.php");
include("uifc/FormFieldBuilder.php");

class Integer extends Number {
  //
  // private variables
  //

  var $width;

  //
  // public methods
  //

  // description: constructor
  // param: page: the Page object this form field lives in
  // param: id: the identifier of this object
  // param: value: the default value
  // param: invalidMessage: message to be shown upon invalid input. Optional
  // param: emptyMessage: message to be shown upon empty input
  //     if the field is not optional. This message is optional
  function Integer(&$page, $id, $value, $invalidMessage, $emptyMessage = "") {
    // superclass constructor
    $this->Number($page, $id, $value, $invalidMessage, $emptyMessage);

    $this->max = 4000000000;
    $this->min = -4000000000;
    $this->width = $GLOBALS["_FormField_width"];
  }

  function setWidth($w) {
	$this->width = $w;
  }

  // description: display the maximum & minimum values
  // param: boolean
  function showBounds($bool) {
    $this->showBounds = $bool;
  }

  function toHtml($style = "") {
    $id = $this->getId();
    $page =& $this->getPage();
    $form =& $page->getForm();
    $formId = $form->getId();

    $builder = new FormFieldBuilder();
    $formField .= $builder->makeTextField($id, $this->getValue(), $this->getAccess(), $this->width, 9, $GLOBALS["_FormField_change"]);

    if($this->showBounds) {
      $formatted_min = $this->localizeNumber($this->min);
      $formatted_max = $this->localizeNumber($this->max);

      $i18n = $page->getI18n();
      $bound_text = $i18n->interpolate('[[palette.integerBounds]]', 
        array("minBound" => $formatted_min, "maxBound" => $formatted_max));

      $formField .= $builder->makeTextField('bounds'.$id, $bound_text, "r", 0, 0, 
        $this->GENERIC_CHANGE_HANDLER);
    }

    $formField .= $builder->makeJavaScript($this, "top.code.Integer_changeHandler", $GLOBALS["_FormField_TextField_submit"]);

    $formField .= "
<SCRIPT LANGUAGE=\"javascript\">
var element = document.$formId.$id;
element.max = $this->max;
element.min = $this->min;
</SCRIPT>
";

    return $formField;
  }
}
